
const { ccclass, property } = cc._decorator;
import { OpenActionType } from '../../mk/system/UISystem';
/**
 * 打开指定名字的面板
 * @author 薛鸿潇
 */
@ccclass
export default class BtnOpenPanel extends cc.Component {

    @property({ displayName: '预制体路径', tooltip: '对应路径：resources/' })
    private panel_name = '';
    @property({ displayName: '打开类型', tooltip: 'normal不操作，closeOther关闭其他，closeLast关闭上一个', type: cc.Enum(OpenActionType) })
    private open_type = OpenActionType.normal;
    @property({ displayName: '点击效果', tooltip: "仅支持 NONE 和 SCALE", type: cc.Enum(cc.Button.Transition) })
    public transition_type: cc.Button.Transition = cc.Button.Transition.NONE;
    @property({ displayName: '完成回调', tooltip: "面板打开完成后触发", type: cc.Component.EventHandler })
    public onComplete: cc.Component.EventHandler[] = [];

    onLoad() {
        if (!this.node.getComponent(cc.Button)) {
            let btn_comp = this.node.addComponent(cc.Button);
            btn_comp.transition = this.transition_type;
        }
    }

    start() {
        this.node.on('click', this.openPanel, this);
    }

    private async openPanel() {
        mk.audio.playEffect("button");
        if (!this.panel_name) return;
        await mk.ui.openPanel(this.panel_name, this.open_type);
        const c_count = this.onComplete.length;
        for (let i = 0; i < c_count; i++) {
            if (this.onComplete[i].handler) this.onComplete[i].emit([])
        }
        mk.console.log('open->' + this.panel_name)
    }
    // update (dt) {}
}
